package com.android.td1;

import java.io.File;
import java.util.Scanner;

import com.android.td1.R;

import android.app.Activity;
import android.os.Bundle;
import android.widget.TextView;

public class TD1 extends Activity {
	
	// Variable stockant la valeur courante de l'etat memoire.
	private String meminfo;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
    }
    
    @Override
    public void onStart() {
    	super.onStart() ;
    	
		// On recupere l'information sur la memoire
		meminfo = get_meminfo();
		
		TextView txt_meminfo;
		// On retrouve la zone de texte
		txt_meminfo = (TextView) findViewById(R.id.TextViewMem);
		// On affiche l'information memoire
		txt_meminfo.setText("Free memory (kB): " + meminfo );


    }
    
	/**
	 * Trouver la quantit de RAM libre dans /proc/meminfo
	 *
	 * @return chane de caractres contenant la quantit de RAM libre
	 */
	String get_meminfo() {
		try 
		{
			// Ouverture du fichier /proc/meminfo, mise en place du scanner
			File file = new File("/proc/meminfo");
			Scanner scan_file = new Scanner(file);

			// On lit la ligne 1, sans l'enregistrer, c'est la ligne 2 qui
			// contient
			// l'information utile : on la met dans une variable.
			scan_file.nextLine();
			String second_line = scan_file.nextLine();

			// Mise en place d'un second scanner, pour decomposer
			// cette ligne en deux elements, delimites par ':'
			Scanner scan_line = new Scanner(second_line);
			scan_file.useDelimiter(":");

			// la premiere partie contient la chaine "MemFree:", la seconde
			// partie contient
			// l'information recherchee.
			scan_line.next();
			String free_memory = scan_line.next();

			// On ferme ce qu'on a ouvert, et en renvoie la qtt de
			// memoire libre
			scan_line.close();
			scan_file.close();
			return new String(free_memory);
		} 
		catch(Exception e)
		{
			return new String("unknown");
		}
	}

}